// ColorBtn.cpp : implementation file
//

#include "stdafx.h"
#include "ColorBtn.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CColorBtn

CColorBtn::CColorBtn(int nBmpX, int nBmpY, int nW, int nH, int nBtnX, int nBtnY):
m_nBmpX(nBmpX),
m_nBmpY(nBmpY),
m_nW(nW), 
m_nH(nH),
m_nBtnX(nBtnX), 
m_nBtnY(nBtnY)

{
	m_nStatus = Normal;
}

CColorBtn::~CColorBtn()
{
}


BEGIN_MESSAGE_MAP(CColorBtn, CButton)
	//{{AFX_MSG_MAP(CColorBtn)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorBtn message handlers

void CColorBtn::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{

	CDC *pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
	CDC BmpDC;

	VERIFY( BmpDC.CreateCompatibleDC(pDC) );
	CBitmap tmpBmp;
	tmpBmp.LoadBitmap(IDB_BKBITMAP);
	CBitmap *pOldBmp = (CBitmap *)BmpDC.SelectObject(&tmpBmp);

	switch(m_nStatus){
		case Normal:
			pDC->BitBlt(lpDrawItemStruct->rcItem.left,
					lpDrawItemStruct->rcItem.top, 
					lpDrawItemStruct->rcItem.right - lpDrawItemStruct->rcItem.left, 
					lpDrawItemStruct->rcItem.bottom -lpDrawItemStruct->rcItem.top, 
					&BmpDC, m_nBmpX, m_nBmpY, SRCCOPY);
		break;
		case Light:
			pDC->BitBlt(lpDrawItemStruct->rcItem.left,
					lpDrawItemStruct->rcItem.top, 
					lpDrawItemStruct->rcItem.right - lpDrawItemStruct->rcItem.left, 
					lpDrawItemStruct->rcItem.bottom -lpDrawItemStruct->rcItem.top, 
					&BmpDC, m_nBmpX+m_nW, m_nBmpY, SRCCOPY);
		break;
		case Pressed:
			pDC->BitBlt(lpDrawItemStruct->rcItem.left,
					lpDrawItemStruct->rcItem.top, 
					lpDrawItemStruct->rcItem.right - lpDrawItemStruct->rcItem.left, 
					lpDrawItemStruct->rcItem.bottom -lpDrawItemStruct->rcItem.top, 
					&BmpDC, m_nBmpX+m_nW*2, m_nBmpY, SRCCOPY);
		break;
	}
	
	BmpDC.SelectObject(pOldBmp);
}

void CColorBtn::Move()
{
	MoveWindow(m_nBtnX, m_nBtnY, m_nW, m_nH); 
}



void CColorBtn::OnMouseMove(UINT nFlags, CPoint point) 
{

	
	if(GetCapture()!=this){
		SetCapture();
	}

	CRect WinRect(0,0,m_nW, m_nH);

	if(WinRect.PtInRect(point)){
		m_nStatus = Light;
	}
	else{
		m_nStatus = Normal;
		if(GetCapture()==this){
			bool bRet = ReleaseCapture();
			if(!bRet){
				ASSERT(0);
			}
		}
	}


	CButton::OnMouseMove(nFlags, point);
	Invalidate(FALSE);
	UpdateWindow();
}

void CColorBtn::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_nStatus = Pressed;
	
	CButton::OnLButtonDown(nFlags, point);
}

void CColorBtn::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_nStatus = Normal;
	
	CButton::OnLButtonUp(nFlags, point);
}
